diff --git a/pithos-macos/PithosSyncDaemon.m b/pithos-macos/PithosSyncDaemon.m
index 5366cd6..81efa3c 100644
--- a/pithos-macos/PithosSyncDaemon.m
+++ b/pithos-macos/PithosSyncDaemon.m
@@ -1674,19 +1765,8 @@
             [(NSMutableDictionary *)(newObjectRequest.userInfo) setObject:NSStringFromSelector(@selector(uploadObjectUsingHashMapFinished:)) forKey:@"didFinishSelector"];
             [networkQueue addOperation:[PithosUtilities prepareRequest:newObjectRequest priority:[[newObjectRequest.userInfo objectForKey:@"priority"] integerValue]]];
         } else {
-            if (newSyncRequested) {
-                dispatch_async(dispatch_get_main_queue(), ^{
-                    [activityFacility endActivity:activity 
-                                      withMessage:[containerRequest.userInfo objectForKey:@"stoppedActivityMessage"]];
-                });
-                @synchronized(self) {
-                    syncIncomplete = YES;
-                    [self decreaseSyncOperationCount];
-                    if (!syncOperationCount)
-                        [self sync];
-                }
-                [pool drain];
-                return;
+            if (newSyncRequested || syncLate || operation.isCancelled) {
+                [self requestFailed:containerRequest];
             } else {
                 __block ASIPithosContainerRequest *newContainerRequest = [PithosUtilities updateContainerDataRequestWithPithos:pithos 
                                                                                                                  containerName:containerName
@@ -1717,27 +1797,17 @@
 
 - (void)requestFailed:(ASIPithosRequest *)request {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
-    if ([request isCancelled]) {
-        dispatch_async(dispatch_get_main_queue(), ^{
-            [activityFacility endActivity:[request.userInfo objectForKey:@"activity"] 
-                              withMessage:[request.userInfo objectForKey:@"stoppedActivityMessage"]];
-        });
-        syncIncomplete = YES;
-        [self decreaseSyncOperationCount];
+    NSOperation *operation = [request.userInfo objectForKey:@"operation"];
+    if (operation.isCancelled) {
         [pool drain];
-        return;
+        return;        
     }
-    if (newSyncRequested) {
+    if (request.isCancelled || newSyncRequested || syncLate) {
         dispatch_async(dispatch_get_main_queue(), ^{
             [activityFacility endActivity:[request.userInfo objectForKey:@"activity"] 
                               withMessage:[request.userInfo objectForKey:@"stoppedActivityMessage"]];
         });
-        @synchronized(self) {
-            syncIncomplete = YES;
-            [self decreaseSyncOperationCount];
-            if (!syncOperationCount)
-                [self sync];
-        }
+        [self syncOperationFinishedWithSuccess:NO];
         [pool drain];
         return;
     }
@@ -1751,8 +1821,7 @@
             [activityFacility endActivity:[request.userInfo objectForKey:@"activity"] 
                               withMessage:[request.userInfo objectForKey:@"failedActivityMessage"]];
         });
-        syncIncomplete = YES;
-        [self decreaseSyncOperationCount];
+        [self syncOperationFinishedWithSuccess:NO];
     }
     [pool drain];
 }
diff --git a/pithos-macos/PithosUtilities.m b/pithos-macos/PithosUtilities.m
index 769b86b..540262a 100644
--- a/pithos-macos/PithosUtilities.m
+++ b/pithos-macos/PithosUtilities.m
@@ -36,6 +36,7 @@
 // or implied, of GRNET S.A.
 
 #import "PithosUtilities.h"
+#import "ASINetworkQueue.h"
 #import "ASIPithos.h"
 #import "ASIPithosContainerRequest.h"
 #import "ASIPithosObjectRequest.h"
@@ -908,10 +909,9 @@
                                                                                          objectName:objectName];
     if (sharingAccount)
         [objectRequest setRequestUserFromDefaultTo:sharingAccount withPithos:pithos];
-    [[PithosUtilities prepareRequest:objectRequest priority:NSOperationQueuePriorityVeryHigh] startAsynchronous];
-    while (![objectRequest isFinished]) {
-        usleep(1);
-    }
+    ASINetworkQueue *networkQueue = [ASINetworkQueue queue];
+    [networkQueue go];
+    [networkQueue addOperations:[NSArray arrayWithObject:[PithosUtilities prepareRequest:objectRequest]] waitUntilFinished:YES];
     *error = [objectRequest error];
     if (*error) {
         [self httpRequestErrorAlertWithRequest:objectRequest];
@@ -975,10 +975,9 @@
                                                                                                         until:nil];
         if (sharingAccount)
             [containerRequest setRequestUserFromDefaultTo:sharingAccount withPithos:pithos];
-        [[PithosUtilities prepareRequest:containerRequest priority:NSOperationQueuePriorityVeryHigh] startAsynchronous];
-        while (![containerRequest isFinished]) {
-            usleep(1);
-        }
+        ASINetworkQueue *networkQueue = [ASINetworkQueue queue];
+        [networkQueue go];
+        [networkQueue addOperations:[NSArray arrayWithObject:[PithosUtilities prepareRequest:containerRequest]] waitUntilFinished:YES];
         if ([containerRequest error]) {
             [self httpRequestErrorAlertWithRequest:containerRequest];
             return nil;
diff --git a/pithos-macos/PublicURLTransformer.m b/pithos-macos/PublicURLTransformer.m
index 7f14fd5..928f0f7 100644
--- a/pithos-macos/PublicURLTransformer.m
+++ b/pithos-macos/PublicURLTransformer.m
@@ -39,6 +39,7 @@
 #import "ASIPithosRequest.h"
 #import "ASIPithos.h"
 #import "pithos_macosAppDelegate.h"
+#import "PithosAccount.h"
 
 @implementation PublicURLTransformer
 
@@ -53,7 +54,7 @@
 - (id)transformedValue:(id)value {
     if (value == nil)
 		return nil;
-    return [[[(pithos_macosAppDelegate *)[[NSApplication sharedApplication] delegate] pithos] publicURLPrefix] 
+    return [[[[(pithos_macosAppDelegate *)[[NSApplication sharedApplication] delegate] currentPithosAccount] pithos] publicURLPrefix] 
             stringByAppendingString:(NSString *)value];
 }
 
